﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Syncfusion.EJ.Export;

namespace ASPMvcRTE.Controllers
{
    public partial class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.value = @"<p>The rich text editor component is WYSIWYG ('what you see is what you get') editor that provides the best user experience to create and update the content. 
                    Users can format their content using standard toolbar commands.</p>
                <p><b> Key features:</b></p>
                <ul><li><p> Provides &lt; IFRAME &gt; and &lt; DIV &gt; modes </p></li>
                    <li><p> Capable of handling markdown editing.</p></li>
                    <li><p> Contains a modular library to load the necessary functionality on demand.</p></li>
                    <li><p> Provides a fully customizable toolbar.</p></li>
                    <li><p> Provides HTML view to edit the source directly for developers.</p></li>";
            var tools = new
            {
                tooltipText = "Import file",
                template = "<button type='button' class='e-tbar-btn e-btn' tabindex='-1' id='custom_tbar'  style='width:100%'><div class='e-tbar-btn-text rtecustomtool' style='font-weight: 500;'>Import</div></button>"
            };
            var tool1 = new
            {
                tooltipText = "Export file",
                template = "<button type='submit' class='e-tbar-btn e-btn' tabindex='-1' id='custom_tbar1'  style='width:100%'><div class='e-tbar-btn-text rtecustomtool' style='font-weight: 500;'>Export</div></button>"
            };
            ViewBag.items = new object[] { "Bold", "Italic", "Underline", "|", "Formats", "Alignments", "OrderedList",
                "UnorderedList", "|", "CreateLink", "Image", "|", "SourceCode", tools, tool1
                , "|", "Undo", "Redo"
            };
            return View();
        }
        [HttpPost]
        public string Import(IEnumerable<HttpPostedFileBase> UploadFiles)
        {
            string HtmlString = string.Empty;
            if (HttpContext.Request.Files.AllKeys.Any())
            {
                foreach (var file in UploadFiles)
                {
                    var fileName = Path.GetFileName(file.FileName);
                    var destinationPath = Path.Combine(Server.MapPath("~/App_Data"), fileName);
                    file.SaveAs(destinationPath);
                    using (var mStream = new MemoryStream())
                    {
                        new WordDocument(file.InputStream).Save(mStream, FormatType.Html);
                        mStream.Position = 0;
                        HtmlString = new StreamReader(mStream).ReadToEnd();
                    };
                    HtmlString = ExtractBodyContent(HtmlString);
                }
            }
            return HtmlString;
        }
        [HttpPost]
        [ValidateInput(false)]
        public void ExportToRtf(string customtool)
        {
            string htmlText = customtool;
            WordDocument document = GetDocument(htmlText);
            document.Save("default" + ".rtf", FormatType.Docx, System.Web.HttpContext.Current.Response, HttpContentDisposition.Attachment);
        }
     
        public string ExtractBodyContent(string html)
        {
            if (html.Contains("<html") && html.Contains("<body"))
            {
                return html.Remove(0, html.IndexOf("<body>") + 6).Replace("</body></html>", "");

            }
            return html;
        }

        public WordDocument GetDocument(string htmlText)
        {
            WordDocument document = null;
            MemoryStream stream = new MemoryStream();
            StreamWriter writer = new StreamWriter(stream, System.Text.Encoding.Default);
            htmlText = htmlText.Replace("\"", "'");
            XmlConversion XmlText = new XmlConversion(htmlText);
            XhtmlConversion XhtmlText = new XhtmlConversion(XmlText);
            writer.Write(XhtmlText.ToString());
            writer.Flush();
            stream.Position = 0;
            document = new WordDocument(stream, FormatType.Html, XHTMLValidationType.None);
            return document;
        }
    }
}